package dev.kske.chess.board;

import java.util.ArrayList;
import java.util.List;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Log.java</strong><br>
 * Created: <strong>09.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Log implements Cloneable {

	private List<LoggedMove> moves;

	public Log() {
		moves = new ArrayList<>();
	}

	public void add(Move move, Piece capturedPiece) {
		moves.add(new LoggedMove(move, capturedPiece));
	}

	public LoggedMove getLast() {
		return moves.get(moves.size() - 1);
	}
	
	public void removeLast() {
		if (!moves.isEmpty()) moves.remove(moves.size() - 1);
	}

	@Override
	public Object clone() {
		Log log = null;
		try {
			log = (Log) super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		log.moves = new ArrayList<>();
		log.moves.addAll(this.moves);
		return log;
	}

	public static class LoggedMove {

		public final Move		move;
		public final Piece	capturedPiece;

		public LoggedMove(Move move, Piece capturedPiece) {
			this.move		= move;
			this.capturedPiece	= capturedPiece;
		}
	}
}
